// Generated by CoffeeScript 1.8.0
(function() {
  angular.module('ajenti.plugins', ['core']);

}).call(this);

// Generated by CoffeeScript 1.8.0
(function() {
  angular.module('core').config(function($routeProvider) {
    return $routeProvider.when('/view/plugins', {
      templateUrl: '/plugins:resources/partial/index.html',
      controller: 'PluginsIndexController'
    });
  });

}).call(this);

// Generated by CoffeeScript 1.8.0
(function() {
  angular.module('ajenti.plugins').controller('PluginsIndexController', function($scope, $http, notify, pageTitle, messagebox, core) {
    pageTitle.set('Plugins');
    $scope.selectedInstalledPlugin = null;
    $scope.selectedRepoPlugin = null;
    $scope.refresh = function() {
      $http.get('/api/plugins/list/installed').success(function(data) {
        return $scope.installedPlugins = data;
      }).error(function(err) {
        return notify.error('Could not installed plugin list', err.message);
      });
      $http.get('/api/plugins/pypi/list').success(function(data) {
        return $scope.pypiList = data;
      });
      return $http.get('/api/plugins/repo/list').success(function(data) {
        return $scope.repoList = data;
      }).error(function(err) {
        return notify.error('Could not load plugin repository', err.message);
      });
    };
    $scope.refresh();
    $scope.isInstalled = function(plugin) {
      var p, _i, _len, _ref;
      if (!$scope.isInstalled) {
        return false;
      }
      _ref = $scope.installedPlugins;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        p = _ref[_i];
        if (p.name === plugin.name) {
          return true;
        }
      }
      return false;
    };
    $scope.isUpgradeable = function(plugin) {
      var p, _i, _len, _ref;
      if (!$scope.repoList || !plugin) {
        return false;
      }
      _ref = $scope.repoList;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        p = _ref[_i];
        if (p.name === plugin.name && p.version !== plugin.version) {
          return true;
        }
      }
      return false;
    };
    $scope.installPlugin = function(plugin) {
      var msg;
      $scope.selectedRepoPlugin = null;
      $scope.selectedInstalledPlugin = null;
      msg = messagebox.show({
        progress: true,
        title: 'Installing'
      });
      return $http.get("/api/plugins/pypi/install/" + plugin.name).success(function() {
        $scope.refresh();
        return messagebox.show({
          title: 'Done',
          text: 'Installed. A panel restart is required.',
          positive: 'Restart now',
          negative: 'Later'
        }).then(function() {
          return $scope.restart();
        });
      }).error(function(err) {
        return notify.error('Install failed', err.message);
      })["finally"](function() {
        return msg.close();
      });
    };
    $scope.uninstallPlugin = function(plugin) {
      var msg;
      $scope.selectedRepoPlugin = null;
      $scope.selectedInstalledPlugin = null;
      if (confirm("Uninstall " + plugin.name + "?")) {
        msg = messagebox.show({
          progress: true,
          title: 'Uninstalling'
        });
        return $http.get("/api/plugins/pypi/uninstall/" + plugin.name).success(function() {
          $scope.refresh();
          return messagebox.show({
            title: 'Done',
            text: 'Uninstalled. A panel restart is required.',
            positive: 'Restart now',
            negative: 'Later'
          }).then(function() {
            return $scope.restart();
          });
        }).error(function(err) {
          return notify.error('Uninstall failed', err.message);
        })["finally"](function() {
          return msg.close();
        });
      }
    };
    return $scope.restart = function() {
      return core.restart();
    };
  });

}).call(this);

